package org.kldp.jmassmailer.data;

import java.sql.*;

/*
 * Created on 2005. 5. 2
 */


/**
 * @author (JeongSoo, Park)
 */
public class JdbcOdbcHandler implements DbHandlerController{
    private String host;
    private String user;
    private String password;
    private Connection con;
    private String sunDriver;
    private String url;
    private PeopleList people;
    
    private String userFieldName;
    private String emailFieldName;
    private String genderFieldName;
    
    public JdbcOdbcHandler(String _host, String _user, String _password) throws ClassNotFoundException, SQLException{
        sunDriver = "sun.jdbc.odbc.JdbcOdbcDriver";
        url = "jdbc:odbc:" + _host;
        user = _user;
        password = _password;
        people = new PeopleList();
        
        Class.forName(sunDriver);
        connect();
        retrieveRecords();
        close();
    }
    
    public String[] getColumns() throws SQLException{
    	connect();
    	close();
        return null;
    }
    
    public PeopleList getPeopleList(){
        return people;
    }
    
    public void connect() throws SQLException{
        con = DriverManager.getConnection(url, user, password);
    }
    
    public void close() throws SQLException{
        con.close();
    }
    
    public void retrieveRecords(){
//        String[] types = {"TABLE"};
//        try{
//            DatabaseMetaData metaData = con.getMetaData();
//            ResultSet rs = metaData.getTables(null, null, "%", types);
//            System.out.println("=== Tables ===");
//            while(rs.next()){
//                System.out.println("Table Name: " + rs.getString("TABLE_NAME"));
//            }
//            rs.close();
//        }catch(SQLException e){
//            e.printStackTrace();
//        }

        String query = "SELECT NAME, EMAIL, GENDER from [Sheet1$]";
//        String query = "CREATE TABLE table1";
        try{
            Statement statement = con.createStatement();
            ResultSet rs = statement.executeQuery(query);
            
            while(rs.next()){
                System.out.print("Name: " + rs.getString(1));
                System.out.print(" E-Mail: " + rs.getString(2));
                System.out.println(" GENDER: " + rs.getString(3));
            }
        }catch(SQLException e){
            e.printStackTrace();
        }
    }
    
}