package org.kldp.jmassmailer.data;
/*
 * Created on 2005. 5. 2
 */

/**
 * @author (JeongSoo, Park)
 */
public class Person {    
	
	/**
	 * A Class contains data of a person. Includes name, email address, gender.
	 * Also includes mutators, a static method which supports personzlied text.
	 * 
	 * @param _name	Name of the person.
	 * @param _email	Email address of the person. (using string)
	 * @param _gender	Gender of the person. (Can choose either Person.MAIL or Person.FEMAIL)
	 */
    public Person(String _name, String _email, int _gender){
        name = _name;
        email = _email;
        gender = _gender;
    }
    
    public void setName(String _name){ name = _name; }
    public void setEmail(String _email){ email = _email; }
    public void setGender(int _gender){ gender = _gender; }
    
    public String getName(){ return name; }
    public String getEmail(){ return email; }
    public int getGender(){ return gender; }

    public static final int FEMAIL = 0;
    public static final int MAIL = 1;
    
    private String name;
    private String email;
    private int gender;
    /**
     * Return a personalized text. If given string include phrases like {*NAME*}, {*EMAIL*}, 
     * this method returns with real name and real email address.
     * 
     * @param content
     * @param _person
     * @return A String which is personalized.  
     */
    public static String personalizeText(String content, Person _person) {
        // TODO Auto-generated method stub
        String replacedString = new String(content);
        
        replacedString = replacedString.replaceAll("[\u007B][\u002A]NAME[\u002A][\u007D]", _person.getName());
        replacedString = replacedString.replaceAll("[\u007B][\u002A]EMAIL[\u002A][\u007D]", _person.getEmail());
//        replacedString = replacedString.replaceAll("[\u007B][\u002A]GENDER[\u002A][\u007D]", (_person.getGender() == Person.MAIL) ? "" : "ڸ");
                
        return replacedString;
    }
    
    public int hashCode(){
    	String hashString = name + email;
    	return hashString.hashCode();
    }
}