/*
 * Created on 2005. 6. 14
 */
package org.kldp.jmassmailer.ui;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GraphicsConfiguration;
import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;

/**
 * @author (JeongSoo, Park)
 */
public abstract class JMyDialog extends JDialog {

    /**
     * @throws java.awt.HeadlessException
     */
    public JMyDialog() throws HeadlessException {
        super();
        initialize();
    }

    /**
     * @param arg0
     * @throws java.awt.HeadlessException
     */
    public JMyDialog(Frame arg0) throws HeadlessException {
        super(arg0);
        initialize();
    }

    /**
     * @param arg0
     * @param arg1
     * @throws java.awt.HeadlessException
     */
    public JMyDialog(Frame arg0, boolean arg1) throws HeadlessException {
        super(arg0, arg1);
        initialize();
    }

    /**
     * @param arg0
     * @param arg1
     * @throws java.awt.HeadlessException
     */
    public JMyDialog(Frame arg0, String arg1) throws HeadlessException {
        super(arg0, arg1);
        initialize();
    }

    /**
     * @param arg0
     * @param arg1
     * @param arg2
     * @throws java.awt.HeadlessException
     */
    public JMyDialog(Frame arg0, String arg1, boolean arg2)
            throws HeadlessException {
        super(arg0, arg1, arg2);
        initialize();
    }

    /**
     * @param arg0
     * @param arg1
     * @param arg2
     * @param arg3
     */
    public JMyDialog(Frame arg0, String arg1, boolean arg2,
            GraphicsConfiguration arg3) {
        super(arg0, arg1, arg2, arg3);
        initialize();
    }

    /**
     * @param arg0
     * @throws java.awt.HeadlessException
     */
    public JMyDialog(Dialog arg0) throws HeadlessException {
        super(arg0);
        initialize();
    }

    /**
     * @param arg0
     * @param arg1
     * @throws java.awt.HeadlessException
     */
    public JMyDialog(Dialog arg0, boolean arg1) throws HeadlessException {
        super(arg0, arg1);
        initialize();
    }

    /**
     * @param arg0
     * @param arg1
     * @throws java.awt.HeadlessException
     */
    public JMyDialog(Dialog arg0, String arg1) throws HeadlessException {
        super(arg0, arg1);
        initialize();
    }

    /**
     * @param arg0
     * @param arg1
     * @param arg2
     * @throws java.awt.HeadlessException
     */
    public JMyDialog(Dialog arg0, String arg1, boolean arg2)
            throws HeadlessException {
        super(arg0, arg1, arg2);
        initialize();
    }

    /**
     * @param arg0
     * @param arg1
     * @param arg2
     * @param arg3
     * @throws java.awt.HeadlessException
     */
    public JMyDialog(Dialog arg0, String arg1, boolean arg2,
            GraphicsConfiguration arg3) throws HeadlessException {
        super(arg0, arg1, arg2, arg3);
        initialize();
    }

    protected void initialize(){
		setResizable(false);
		setSize();
		
		Dimension dim = getToolkit().getScreenSize();
		setLocation(dim.width / 2 - this.getWidth() / 2, dim.height / 2 - this.getHeight() / 2);

		Container con = this.getContentPane();
		con.setLayout(new BorderLayout());
		
		JPanel mainPanel = getMainPanel();
		JPanel buttonPanel = getBtnPanel();
		
		con.add(mainPanel, BorderLayout.CENTER);
		con.add(buttonPanel, BorderLayout.SOUTH);
    }
    
    private JPanel getBtnPanel(){
		JPanel panelButton = new JPanel();
		JButton btnOk = new JButton("OK");
		btnOk.addActionListener(new ActionListener(){
		    public void actionPerformed(ActionEvent arg0){
		        okActionPerformed();
		    }
		});
		
		JButton btnCancel = new JButton("Cancel");
		btnCancel.addActionListener(new ActionListener(){
		    public void actionPerformed(ActionEvent arg0){
		        cancelActionPerformed();
		    }
		});
		
		panelButton.setLayout(new BoxLayout(panelButton, BoxLayout.X_AXIS));
		panelButton.add(btnOk);
		panelButton.add(btnCancel);
		
		return panelButton;
    }
    

    protected void close(){
	    setVisible(false);
	}

	protected abstract JPanel getMainPanel();
    protected abstract void okActionPerformed();
    protected abstract void cancelActionPerformed();
    protected abstract void setSize();
}
