package org.kldp.jmassmailer.ui;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.sql.SQLException;

import javax.swing.*;
import javax.swing.border.*;
import javax.mail.AuthenticationFailedException;
import javax.mail.MessagingException;
import javax.mail.NoSuchProviderException;

import org.kldp.jmassmailer.data.*;
import org.kldp.jmassmailer.mail.*;


/*
 * Created on 2005. 5. 16
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author toracle
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MailerMainWindow extends JFrame {
	// Basic Classes
    protected SessionHandlerController shc;
	protected PeopleList people;
	
	// Dialogs
	private SmtpHostDialog smtpDialog; 
	
	// Main Panels
	private JPanel contentPanel;
	private JPanel mainButtonPanel;
	
	// Layout
	private CardLayout contentLayout;
	
    /**
     * 
     */
    public MailerMainWindow(){
		// Set Default Window initialization
        super("jmassmailer");
		setDefaultCloseOperation(EXIT_ON_CLOSE);

		try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, "Can't load system Look and Feel.\nDefault Look and Feel would be used.");
        }        		
		
        // Set size and location
        setSize(700, 500);
        Dimension dim = getToolkit().getScreenSize();
        setLocation(dim.width / 2 - this.getWidth() / 2, dim.height / 2 - this.getHeight() / 2);
        setLayout(new BorderLayout());
        
        // Create MenuBar
        JMenuBar menubar = createMenu();
        setJMenuBar(menubar);
        
        // Create main button panel
        mainButtonPanel = createMainButtonPanel();
        
        // Create Main Panels
        getContentPane().add(mainButtonPanel, BorderLayout.WEST);
        contentPanel = new JPanel();
        getContentPane().add(contentPanel, BorderLayout.CENTER);
        contentLayout = new CardLayout();
        contentPanel.setLayout(contentLayout);

        // Create Buttons on Button Panel
        
        SmtpHostDialog _smtpDialog = (SmtpHostDialog)loadConfigureFile(".smtp.ser");
//        smtpDialog = new ConfigureSmtpHostDialog(this, "Configure SMTP Host", true);
//        smtpDialog.setAttributes(_smtpDialog);
//        smtpDialog = new ConfigureSmtpHostDialog(this, "Configure SMTP Host", true);
//        ConfigureOdbcDialog _odbcDialog = (ConfigureOdbcDialog)loadConfigureFile(".odbc.ser");
//        odbcDialog = new ConfigureOdbcDialog(this, "Configure ODBC", true);
////        odbcDialog.setAttributes(_odbcDialog);
        
        people = new PeopleList();
        
        // PeopleList Test Code
        people = new PeopleList();
        people.add(new Person("Jeong Soo, Park", "toracle@teramail.com", Person.MAIL));
        people.add(new Person("Jeong Soo, Park", "toracle@gmail.com", Person.MAIL));
        
        setVisible(true);
	}
	
	/**
     * @param string
     * @return
     */
    private JMyDialog loadConfigureFile(String filename) {
        JMyDialog dialog = null;
        File dialogFile = new File(filename);
        if(dialogFile.isFile()){
            try {
                ObjectInputStream in = new ObjectInputStream(new FileInputStream(dialogFile));
                dialog = (JMyDialog)in.readObject();
            } catch (FileNotFoundException e1) {
                System.err.println("Previous setting file; " + filename + " is not found.\nWould use default (null) values.");
            } catch (IOException e1) {
                System.err.println("Error occurs during reading previous setting; " + filename + "\nWould use default (null) values.");
            } catch (ClassNotFoundException e) {
                System.err.println("Configuration file " + filename + "is might be currupted.\nWould use default (null) values.");
            }
        }
        return dialog;
    }
    
    private void saveConfigureFile(String filename, Object object){
        File objectFile = new File(filename);
        ObjectOutputStream out = null;
//        if(objectFile.exists()){
//            objectFile.delete();
//        }
        
        try {
            objectFile.createNewFile();
        } catch (IOException e){
            System.err.println("Configuration file creation error" + e.getMessage());
        }
        
        try {
            out = new ObjectOutputStream(new FileOutputStream(objectFile));
        } catch (IOException e){
            System.err.println("Configuration file input streen open error" + e.getMessage());
        }
        
        try {            
            out.writeObject(object);
        } catch (IOException e){
            System.err.println("An Error occurs during saving configuration file.\n" + e.getMessage());
            e.printStackTrace();
        }
    }

    /**
     * @return
     */
    private JPanel createMainButtonPanel() {
        JPanel mainPanel = new JPanel();
        mainPanel.setLayout(new BorderLayout());
        
        JPanel viewPanel = new JPanel();
        viewPanel.setBorder(new TitledBorder(new EtchedBorder(), "View"));
        viewPanel.setLayout(new GridLayout(15, 1));
        
        JButton btnMailingList = new JButton("Mailing List");
        btnMailingList.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent arg0){
                contentLayout.show(contentPanel, "MailingList");
            }
        });
        viewPanel.add(btnMailingList);
        
        JButton btnComposeMessage = new JButton("Message");
        btnComposeMessage.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent arg0){
                contentLayout.show(contentPanel, "Message");
            }
        });
        viewPanel.add(btnComposeMessage);

        mainPanel.add(viewPanel, BorderLayout.CENTER);
        
        JButton btnSend = new JButton("Send");
        btnSend.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent arg0){
//                contentLayout.show(contentPanel, "Send");
                sendMessages();
            }
        });
        mainPanel.add(btnSend, BorderLayout.SOUTH);        
        
        return mainPanel;
    }

    private JMenuBar createMenu(){
        JMenuBar menubar = new JMenuBar();
        
//        JMenu fileMenu = new JMenu(language.fileMenu());
//        fileMenu.setMnemonic('f');

/* Didn't Implemented yet
        fileMenu.add(new ActionMenu("Save Logs To..."){
            public void actionPerformed(ActionEvent arg0){
                
            }            
        });
        fileMenu.addSeparator();
*/        
        
//        fileMenu.add(new ActionMenu(language.importMessage()){
//            public void actionPerformed(ActionEvent arg){
//                importMessage();
//            }
//        });

//        JMenu importMailingListMenu = new JMenu(language.importMailingList());
//        fileMenu.add(importMailingListMenu);
        
//        importMailingListMenu.add(new ActionMenu(language.fromExcelFile()){
//            public void actionPerformed(ActionEvent arg0){
//                importExcelFile();
//            }            
//        });
//          
//        importMailingListMenu.add(new ActionMenu(language.fromCsvFile()){
//            public void actionPerformed(ActionEvent arg0){
//                importCsvFile();
//            }            
//        });
        
//        importMailingListMenu.add(new ActionMenu(language.fromOdbc()){
//            public void actionPerformed(ActionEvent arg){
//                configureJdbcOdbc();
//            }
//        });
        
/* Didn't Implemented yet
        fileMenu.add(new ActionMenu("Export Reciepents List"){
            
        });

        fileMenu.addSeparator();

        fileMenu.add(new ActionMenu("Open Configuration File"){
            
        });

        fileMenu.add(new ActionMenu("Save Configuration To..."){
            public void actionPerformed(ActionEvent arg0){
                
            }
        });
*/
//        fileMenu.addSeparator();

//        fileMenu.add(new ActionMenu(language.quit(), KeyStroke.getKeyStroke(KeyEvent.VK_Q, KeyEvent.CTRL_DOWN_MASK)){
//            public void actionPerformed(ActionEvent arg0){
//                int value = JOptionPane.showConfirmDialog((Component)arg0.getSource(), "Really want to exit?", "Exit", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
//                if(value == 0){
//                    finalizer();
//                    System.exit(0);
//                }
//            }
//        });
        
//        menubar.add(fileMenu);

/* Didn't implemented yet        
        JMenu editMenu = new JMenu("Edit");
        editMenu.setMnemonic('e');
        menubar.add(editMenu);
                
        JMenu viewMenu = new JMenu("View");
        viewMenu.setMnemonic('v');
        JMenuItem menuitem = null;
        viewMenu.add(menuitem = new ActionCheckMenu("Toggle Status Pane", true){
            public void actionPerformed(ActionEvent arg0){
                
            }
        });
        menubar.add(viewMenu);
*/
        
        JMenu configureMenu = new JMenu("Configuration");
        configureMenu.setMnemonic('c');
        menubar.add(configureMenu);
        
        configureMenu.add(new ActionMenu("Configure SMTP Host", KeyStroke.getKeyStroke(KeyEvent.VK_P, KeyEvent.CTRL_DOWN_MASK)){
            public void actionPerformed(ActionEvent arg0){
            	configureSmtpHost();
            }            
        });
        
        configureMenu.addSeparator();
        
//        configureMenu.add(new ActionMenu("Configure ODBC", KeyStroke.getKeyStroke(KeyEvent.VK_B, KeyEvent.CTRL_DOWN_MASK)){
//            public void actionPerformed(ActionEvent arg0){
//                configureJdbcOdbc();
//            }
//        });
//        
//        configureMenu.add(new ActionMenu("Configure Database Column"){
//            public void actionPerformed(ActionEvent arg0){
//                configureColumn();
//            }
//        });
                                        
        JMenu helpMenu = new JMenu("Help");
        helpMenu.setMnemonic('h');
        menubar.add(helpMenu);
        
/* Didn't implemented yet
        helpMenu.add(new ActionMenu("Contents"){
            public void actionPerformed(ActionEvent arg0){
                
            }
        });
        helpMenu.add(new ActionMenu("Visit Web site"){
            public void actionPerformed(ActionEvent arg0){
                
            }
        });
        helpMenu.addSeparator();
        helpMenu.add(new ActionMenu("About"){
            public void actionPerformed(ActionEvent arg0){
                
            }
        });
*/      
        
        return menubar;
	}
	
	/**
	 * 
	 */
	private void configureSmtpHost(){
		smtpDialog.setVisible(true);
		// Test Code : insertion of peoplelist is hard coded		
	}
	
	/**
	 * 
	 */	
//	private void configureJdbcOdbc(){
//	    odbcDialog.setVisible(true);
//	    try {
////            connector = odbcDialog.getSqlConnector();
//        } catch (ClassNotFoundException e) {
//            JOptionPane.showMessageDialog(this, "ODBC Error : " + e.getLocalizedMessage(), "ODBC Error", JOptionPane.ERROR_MESSAGE);
//        } catch (SQLException e) {
//            JOptionPane.showMessageDialog(this, "ODBC Error : " + e.getLocalizedMessage(), "ODBC Error", JOptionPane.ERROR_MESSAGE);
//        }
//        
////        refreshMailingList(connector);
//	}
	
	private void refreshMailingList(DbHandlerController handler){
	    
	}
	
	/**
	 * 
	 */
//	private void importMessage(){
//	    
//	}
	
	/**
	 * 
	 */
	private void sendMessages(){
//		shc.sendMessages();
	}
	
	
	/**
	 * 
	 */
//	private void importExcelFile(){
//	    JOptionPane.showMessageDialog(this, "Locate File Chooser", "Todo", JOptionPane.INFORMATION_MESSAGE);
//	    
//	}
//	
//	private void importCsvFile(){
//	    JOptionPane.showMessageDialog(this, "Locate File Chooser", "Todo", JOptionPane.INFORMATION_MESSAGE);
//	}
//	
//	private void configureColumn(){
//	    JOptionPane.showMessageDialog(this, "Configure Column Dialog", "Todo", JOptionPane.INFORMATION_MESSAGE);
//	}
	
	private void finalizer(){
	    //JOptionPane.showMessageDialog(this, "Performs some finalizing code", "Todo", JOptionPane.INFORMATION_MESSAGE);
	    saveConfigureFile(".smtp.ser", smtpDialog);
//	    saveConfigureFile(".odbc.ser", odbcDialog);
	    // File Persistance
	}
}