package org.kldp.jmassmailer.ui;

import org.kldp.jmassmailer.data.*;
import java.awt.*;
import java.awt.event.*;
import javax.mail.AuthenticationFailedException;
import javax.mail.MessagingException;
import javax.mail.NoSuchProviderException;
import javax.mail.internet.AddressException;
import javax.swing.*;
import javax.swing.border.*;



public class MailerView implements ActionListener, TransferObserver {
//	private SessionModelInterface model;
	private SessionControllerInterface controller;
	
	private JFrame viewFrame;
	private JFrame progressFrame;
	private JTextField recipient;
	private JTextField sender;
	private JTextArea messageContent;
	private JTextField messageSubject;
	private JButton sendButton;
	private SmtpHostDialog smtpDialog;
	private JProgressBar transferProgress;
	
	
	public MailerView(SessionControllerInterface controller, SessionModelInterface model){
		this.controller = controller;
//		this.model = model;
	}
	
	public void createView(){
		viewFrame = new JFrame("JMassmailer");
		viewFrame.setSize(400, 400);
		
		viewFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            JOptionPane.showMessageDialog(viewFrame, "Can't load system Look and Feel.\nDefault Look and Feel would be used.");
        }
        
        viewFrame.setJMenuBar(createMenu());
        
        recipient = new JTextField();
        sender = new JTextField();
		messageSubject = new JTextField();
        messageContent = new JTextArea();
        messageContent.setBorder(new EtchedBorder());
        
        JPanel messageComposePanel = new JPanel();
        messageComposePanel.setLayout(new BoxLayout(messageComposePanel, BoxLayout.Y_AXIS));
        
//        JPanel senderPanel = new JPanel();
//        senderPanel.setLayout(new BorderLayout());
//        senderPanel.add(new JLabel(" "), BorderLayout.WEST);
//        senderPanel.add(sender);
//        messageComposePanel.add(senderPanel, BorderLayout.NORTH);
        
        JPanel recipientPanel = new JPanel();
        recipientPanel.setLayout(new BorderLayout());
        JLabel recipientLabel = new JLabel("޴ ");
        recipientLabel.setLabelFor(recipient);
        recipientPanel.add(recipientLabel, BorderLayout.WEST);
        recipientPanel.add(recipient);
        messageComposePanel.add(recipientPanel, BorderLayout.NORTH);
        
        JPanel messageSubjectPanel = new JPanel();
        messageSubjectPanel.setLayout(new BorderLayout());
        JLabel subjectLabel = new JLabel("");
        subjectLabel.setLabelFor(messageSubject);
        messageSubjectPanel.add(subjectLabel, BorderLayout.WEST);
        messageSubjectPanel.add(messageSubject);
        messageComposePanel.add(messageSubjectPanel, BorderLayout.NORTH);
        
        JPanel messageContentPanel = new JPanel();
        messageContentPanel.setLayout(new BorderLayout());
        messageContentPanel.add(new JLabel(""), BorderLayout.WEST);
        messageContentPanel.add(messageContent);
        messageComposePanel.add(messageContentPanel, BorderLayout.CENTER);
		
		viewFrame.getContentPane().setLayout(new BorderLayout());
		viewFrame.getContentPane().add(messageComposePanel, BorderLayout.CENTER);
		
		sendButton = new JButton("Send");
		sendButton.addActionListener(this);
		viewFrame.getContentPane().add(sendButton, BorderLayout.SOUTH);
		
		viewFrame.setVisible(true);
		
		smtpDialog = new SmtpHostDialog(viewFrame, "SMTP ȣƮ ", true);
		smtpDialog.registerObserver((SmtpHostObserver)controller);
		smtpDialog.registerObserver((AddressObserver)controller);
	}
	
	public JMenuBar createMenu(){
		JMenuBar menubar = new JMenuBar();

		JMenu fileMenu = new JMenu("");
		fileMenu.setMnemonic('f');
		fileMenu.add(new ActionMenu("", KeyStroke.getKeyStroke(KeyEvent.VK_Q, KeyEvent.CTRL_DOWN_MASK)){
			public void actionPerformed(ActionEvent arg0){
				int value = JOptionPane.showConfirmDialog((Component)arg0.getSource(), "Really want to exit?", "Exit", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
				if(value == 0){
					finalizer();
					System.exit(0);
				}
			}
		});
		menubar.add(fileMenu);
		
		JMenu confMenu = new JMenu("");
		confMenu.setMnemonic('c');
		
		confMenu.add(new ActionMenu("SMTP ", KeyStroke.getKeyStroke(KeyEvent.VK_P, KeyEvent.ALT_DOWN_MASK)){
			public void actionPerformed(ActionEvent arg){
				smtpDialog.setVisible(true);
			}
		});
		menubar.add(confMenu);
				
		return menubar;
	}
	
	public void actionPerformed(ActionEvent arg0) {
		if(arg0.getSource() == sendButton){
			PeopleList people = new PeopleList();
			people.add(new Person("", recipient.getText(), Person.MAIL));

			controller.setPeopleList(people);
			controller.setMessage(messageSubject.getText(), messageContent.getText());
			
			progressFrame = new JFrame("޼ ...");
			transferProgress = new JProgressBar(0, 100);
			progressFrame.getContentPane().add(transferProgress);
			progressFrame.setSize(100, 20);
			progressFrame.setVisible(true);
			
			try {
				controller.sendMessages();
			} catch (NoSuchProviderException e) {
				JOptionPane.showMessageDialog(viewFrame, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
			} catch (AuthenticationFailedException e) {
				JOptionPane.showMessageDialog(viewFrame, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
			} catch (MessagingException e) {
				JOptionPane.showMessageDialog(viewFrame, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
			}
		}

	}

	public void finalizer(){
		
	}
	
	public void updateMessageSend(int percent, String email){
		transferProgress.setValue(percent);
	}
	
	public void updateMessageSendFinished(){
		JOptionPane.showMessageDialog(null, " ϷǾϴ.", " Ϸ", JOptionPane.INFORMATION_MESSAGE);
		progressFrame.dispose();
	}
}
