package org.kldp.jmassmailer.ui;

import java.util.Properties;

import javax.mail.*;
import javax.mail.internet.*;

import org.kldp.jmassmailer.data.PeopleList;
import org.kldp.jmassmailer.mail.SessionHandler;
import org.kldp.jmassmailer.ui.MailerView;

public class SessionHandlerController implements SessionControllerInterface, SmtpHostObserver, PeopleListObserver, AddressObserver{
	SessionHandler model;
	MailerView view;

	public SessionHandlerController(SessionHandler model){
		this.model = model;
		view = new MailerView(this, model);
		model.registerObserver(view);
		view.createView();
		view.createMenu();
	}

	public void setPeopleList(PeopleList people){
		model.setPeopleList(people);
	}
	
	public void setMessage(String subject, String text) {
		model.setMessage(subject, text);
	}
	
	public void setReplyTo(String replyto) throws AddressException{
		model.setReplyTo(replyto);
	}
	
	public void setFrom(String email) throws AddressException {
		model.setFrom(email);
	}
	
	public void setFrom(String email, String name) throws AddressException{
		model.setFrom(email, name);
	}
	
	public void sendMessages() throws NoSuchProviderException, AuthenticationFailedException, MessagingException{
		model.generateMessages();
		Thread doTransfer = new Thread(model);
        doTransfer.start();
	}

	public void updateSessionConfiguration(Properties props, Authenticator auth){
    	model.createSession(props, auth);
	}
	
	public void updatePeopleList(PeopleList people) throws MessagingException{
    	model.setPeopleList(people);
	}
	
	public void updateFrom(String from) throws AddressException{
		model.setFrom(from);
	}
	
	public void updateReplyTo(String replyto) throws AddressException{
		model.setReplyTo(replyto);
	}

	public void updateFrom(String email, String name) throws AddressException {
		model.setFrom(email, name);
	}
}
