package test;

import junit.framework.TestCase;
import org.kldp.jmassmailer.data.Person;

public class TestPerson extends TestCase {
	Person person1;
	Person person2;
	
	
	protected void setUp() throws Exception {
		super.setUp();
		person1 = new Person("", "toracle@gmail.com", Person.MAIL);
		person2 = new Person("2", "toracle@freechal.com", Person.FEMAIL);
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

	public void testGetName(){
		assertEquals(person1.getName(), "");
		assertEquals(person2.getName(), "2");
	}
	
	public void testGetEmail(){
		assertEquals(person1.getEmail(), "toracle@gmail.com");
		assertEquals(person2.getEmail(), "toracle@freechal.com");
	}
	
	public void testPersonalizedText(){
		String str = "{*NAME*} ȳϼ?";
		assertEquals(Person.personalizeText(str, person1), " ȳϼ?");
		str = "{*EMAIL*}  ½ϴ.";
		assertEquals(Person.personalizeText(str, person1), "toracle@gmail.com  ½ϴ.");
	}
}
