package test;

import junit.framework.TestCase;

import org.kldp.jmassmailer.data.PeopleList;
import org.kldp.jmassmailer.data.Person;
import org.kldp.jmassmailer.mail.*;

import java.io.IOException;
import java.util.Properties;
import javax.mail.Address;
import javax.mail.AuthenticationFailedException;
import javax.mail.Authenticator;
import javax.mail.MessagingException;
import javax.mail.NoSuchProviderException;
import javax.mail.PasswordAuthentication;
import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;
import javax.swing.JFrame;
import javax.swing.JProgressBar;

public class TestSessionHandler extends TestCase {
	Properties props;
	SessionHandler sh;
	
	PeopleList people;
	
	protected void setUp() throws Exception {
		super.setUp();
		props = new Properties();
		
		props.setProperty("mail.transport.protocol", "smtp");
        props.setProperty("mail.smtp.auth", "true"); 
        props.setProperty("mail.smtp.allow8bitmime", "true");
        
        people = new PeopleList();
        people.add(new Person("1", "toracle@freechal.com", Person.MAIL));
        people.add(new Person("2", "toracle@gmail.com", Person.MAIL));
        people.add(new Person("3", "toracle@teramail.com", Person.MAIL));


	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

//	public void testConnectToFreechal(){
//		props.setProperty("mail.host", "smtp.freechal.com");
//		props.setProperty("mail.smtp.starttls.enable", "true");
//        props.setProperty("mail.smtp.port", "25");	// 25, 465, 587, 995
//        
//        sh = new SessionHandler(props, new AuthenticatorImpl("", ""));
//        createSession(sh);
//        transfer();
//	}
//	
	public void testConnectToGmail(){
		props.setProperty("mail.host", "smtp.gmail.com");
		props.setProperty("mail.smtp.starttls.enable", "true");
        props.setProperty("mail.smtp.port", "587");	// 25, 465, 587, 995
        
        sh = new SessionHandler(props, new AuthenticatorImpl("toracle", "mfgcedxd"));
        createSession(sh);
        
        transfer();		
	}
	
	public void testInetAddressToString(){
		Address address = null;
    	try {
			address = new InternetAddress("toracle@gmail.com");
		} catch (AddressException e) {
			
		}
		assertEquals(address.toString(), "toracle@gmail.com");
	}
	
	public void testTransferProgress(){
		JFrame frame = new JFrame("Test Progress");
		frame.setSize(100, 20);
		
		JProgressBar transferProgress = new JProgressBar(0, 100);
		frame.getContentPane().add(transferProgress);
		frame.setVisible(true);
		
		
		
		
	}
	
//	public void updateMessageSend(int percent, String email){
//		
//	}
	
	void transfer(){
		boolean passed = true;
		try {
			sh.transfer();
		} catch (NoSuchProviderException e) {
			System.out.println("No Such Provider: " + e.getMessage());
			passed = false;
		} catch (AuthenticationFailedException e) {
			System.out.println("Authentication Failed: " + e.getMessage());
			passed = false;
		} catch (MessagingException e) {
			System.out.println("Messaging Exception: " + e.getMessage());
			passed = false;
		}
		
		assertEquals(passed, true);		
	}
	
	void createSession(SessionHandler s) {
        s.setPeopleList(people);
        try {
			s.setReplyTo("toracle@freechal.com");
		} catch (AddressException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        try {
			s.setFrom("toracle@gmail.com", "");
		} catch (AddressException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		s.setMessage("ȳϼ", "ȳϼ? <font color=\"blue\">{*NAME*}</font>.");
	}
}
